//grundplatteX = 180;
//grundplatteY = 180;
bohrOffset = 0.54;
ledBohrung = 3.0;
AnzahlX = 10;
AnzahlY = 11;
blockKante = 16;
blockhoehe = 11;
Wandstaerke = 1;
boden=0.8;
bodenAussen=1.5;  //Bodendicke

fn = 24;

module block(a,z,w,lh,lw,boden){ //Kantenlaenge aussen, Hoehe, Wandstaerke, LedHoehe, ledWandstaerke, bodendicke
a2 = a/2;
x1 = a-2*w;
	difference(){
            translate([-a2, -a2,0])
            cube([a,a,z]);
		
		cylinder(d=ledBohrung+bohrOffset, h=a*3, $fn=fn, center=true);
		difference(){
			translate([-x1/2, -x1/2, boden])
			cube([x1,x1,z]);
			cylinder(d1=ledBohrung+bohrOffset+lw,d2=ledBohrung+bohrOffset+lw/2, h=lh, $fn=fn, center=false);
		}
	}
}

translate([-blockKante, -blockKante, 0]){ //Der Boden mit den  Ecklöchern
	difference(){
		color("blue")
		cube([(AnzahlX +1.0)* blockKante,  (AnzahlY +0.5)* blockKante, bodenAussen]);
		
		translate([blockKante/4, blockKante/4, 0])
		cylinder(d=3.2+bohrOffset, h=bodenAussen*3, center=true, $fn=fn);
		
		translate([(AnzahlX +0.5)* blockKante - blockKante/4, blockKante/4, 0])
		cylinder(d=3.2+bohrOffset, h=bodenAussen*3, center=true, $fn=fn);
		
		translate([blockKante/4, (AnzahlY +0.5)* blockKante - blockKante/4, 0])
		cylinder(d=3.2+bohrOffset, h=bodenAussen*3, center=true, $fn=fn);
		
		translate([(AnzahlX +0.5)* blockKante - blockKante/4, (AnzahlY +0.5)* blockKante - blockKante/4, 0])
		cylinder(d=3.2+bohrOffset, h=bodenAussen*3, center=true, $fn=fn);
		translate([blockKante/2+1,blockKante/2+1,-0.01])
		cube([AnzahlX*(blockKante-Wandstaerke)-1,  AnzahlY * (blockKante - Wandstaerke)-1,  10 ]);



        //die 4 Minutenleds durchbohren
        for (y=[0:3]){
            translate([11*(blockKante-Wandstaerke)+1,(y+4.5)*(blockKante-Wandstaerke)+1,0])
            cylinder(d=ledBohrung+bohrOffset, h=99, $fn=fn, center=true);
        }
	}
}

color("yellow")
for (y=[0:AnzahlY-1]){
	for (x=[0:AnzahlX-1]){
		translate([x*(blockKante-Wandstaerke),y*(blockKante-Wandstaerke),0])
		block(a=blockKante,z=blockhoehe,w=Wandstaerke,lh=2.5,lw=3, boden=boden);
	}
}

color("white")
for (y=[0:3]){
    translate([10*(blockKante-Wandstaerke),(y+3.5)*(blockKante-Wandstaerke),0])
    block(a=blockKante,z=blockhoehe,w=Wandstaerke,lh=2.5,lw=3, boden=boden);
}

/*
translate([-20,-20,0])
color ("red")
cube([200,  200, 0.3]);
*/